#pragma once

#include <QWidget>
#include "ui_QtCameraWidget.h"

#include <QCameraInfo>
#include <QCameraViewfinder> 
#include <QCameraImageCapture>
#include <QBuffer> 
#include <QFileDialog> 
#include <QSaveFile>
#include <QMessageBox>


class QtCameraWidget : public QWidget
{
	Q_OBJECT

public:
	QtCameraWidget(QWidget *parent = Q_NULLPTR);
	~QtCameraWidget();
	QByteArray GetMyPhoto();
	QCameraImageCapture *imagecapture;

private:
	Ui::QtCameraWidget ui;

	QScopedPointer<QCamera> m_camera;
	QScopedPointer<QCameraImageCapture> m_imageCapture;
	void SetCamera(const QCameraInfo& cameraInfo);
	QVariant boxValue(const QComboBox *box) const;


private slots:
	void on_DoPhotoPushButton_clicked();
	void on_SavePushButton_clicked();
	void CameraChange(int);
	void DoResChange(int);
	void processCapturedImage(int requestId, const QImage& img);
	void imageSaved(int id, const QString& fileName);
	void do_show();

signals:
	void DoSendPhoto();



};
