#pragma once

#include <QWidget>
#include <QHostAddress> 
#include <QUdpSocket> 
#include <QTextCodec>
#include <QMessageBox> 
#include <QMenu> 
#include <QDateTime> 
#include <QPainter>

#include "ui_QtChatWidget.h"


class QtChatWidget : public QWidget
{
	Q_OBJECT

public:
	QtChatWidget(QWidget *parent = Q_NULLPTR);
	~QtChatWidget();
	void set_port(const int& port);
	void change_port(const int& new_port);
	void load_skin(const QString &stName);
	QPixmap chat_bk, chat_bk_copy;


private:
	Ui::QtChatWidget ui;
	QUdpSocket* udpSocket;

protected:
	int my_port;
	QMenu* mymenu;
	void paintEvent(QPaintEvent *);
	void resizeEvent(QResizeEvent *event);


private slots:
	void do_show();
	void on_sendButton_clicked();
	void readPendingDatagrams();
	void returnPressed();
	void on_ReconnectButton_clicked();
	void on_chatEdit_customContextMenuRequested(QPoint);
	void clear_all();

};
