#include "QtDemoAddInNative.h"
#include <locale.h>


#include <stdio.h>
#include <wchar.h>
#include <string>


#include <iostream>
#include <process.h>
using namespace std;

#define TIME_LEN 65

#define BASE_ERRNO     7

#ifdef WIN32
#pragma setlocale("ru-RU" )
#endif

static const wchar_t *g_PropNames[] = {
	L"IsEnabled",
	L"IsTimerPresent",
	L"InterfaceLanguageCode",
};
static const wchar_t *g_MethodNames[] = {
	L"Play",
	L"Stop",
	L"GenerateError",
	L"SendTextToWidget",
	L"GetPhoto"
};

static const wchar_t *g_PropNamesRu[] = {
	L"",
	L"",
	L"",
};
static const wchar_t *g_MethodNamesRu[] = {
	L"",
	L"",
	L"",
	L"",
	L""
};


static const WCHAR_T g_kClassNames[] = u"CAddInNative"; //"|OtherClass1|OtherClass2";

static IAddInDefBase *pAsyncEvent = NULL;
IAddInDefBase* m_iConnect = NULL;


uint32_t convToShortWchar(WCHAR_T** Dest, const wchar_t* Source, uint32_t len = 0);
uint32_t convFromShortWchar(wchar_t** Dest, const WCHAR_T* Source, uint32_t len = 0);
uint32_t getLenShortWcharStr(const WCHAR_T* Source);

static std::u16string s_names(g_kClassNames);
static AppCapabilities g_capabilities = eAppCapabilitiesInvalid;

QtWidgetsDemoClass* demoQtClass;
my_utils* utils;
QtCameraWidget* cameraWidget;
QtChatWidget* chatWidget;
QtDemoAddInNative* my_pointer_for_QtDemoAddInNative;


std::wstring s2ws(const std::string& s)
{
	int len;
	int slength = (int)s.length() + 1;
	len = MultiByteToWideChar(CP_UTF8, 0, s.c_str(), slength, 0, 0);

	std::wstring r(len, L'\0');
	MultiByteToWideChar(CP_UTF8, 0, s.c_str(), slength, &r[0], len);
	return r;
}

my_utils::my_utils()
{
	QObject::connect(demoQtClass, SIGNAL(DoSendExternalEvent(const QString&, const QString&)), this, SLOT(do_send_alarm(const QString&, const QString&)));
	QObject::connect(this, SIGNAL(do_addTextEdittText(const QString&)), demoQtClass, SLOT(addTextEdittText(const QString&)));

	QObject::connect(this, SIGNAL(do_play_sound(const QString&)), demoQtClass, SLOT(doPlaySound(const QString&)));
	QObject::connect(this, SIGNAL(do_stop_play_sound()), demoQtClass, SLOT(doStopSound()));

	QObject::connect(demoQtClass, SIGNAL(show_camera_widget()), cameraWidget, SLOT(do_show()));
	QObject::connect(demoQtClass, SIGNAL(show_chat_widget()), chatWidget, SLOT(do_show()));
}

my_utils::~my_utils()
{
	if (demoQtClass)
	{
		demoQtClass->deleteLater();
	}

	if (cameraWidget)
	{
		cameraWidget->deleteLater();
	}


	if (chatWidget)
	{
		chatWidget->deleteLater();
	}

}

void my_utils::do_send_alarm(const QString my_event, const QString my_data)
{
	
	WCHAR_T* _event = 0;
	std::wstring std_str = s2ws(my_event.toStdString().c_str());
	const wchar_t* data = std_str.c_str();
	::convToShortWchar(&_event, data);


	WCHAR_T* _data = 0;
	std::wstring std_str1 = s2ws(my_data.toStdString().c_str());
	const wchar_t* data1 = std_str1.c_str();
	::convToShortWchar(&_data, data1);

	my_pointer_for_QtDemoAddInNative->DoExternalEvent((wchar_t*)_event, (wchar_t*)_data);
}

void my_utils::do_send_photo()
{
	//my_pointer_for_QtDemoAddInNative->DoExternalEvent((wchar_t*)_event, (wchar_t*)_data);
}

void my_utils::do_send_data(const QString my_data)
{
	emit do_addTextEdittText(my_data);
}

void my_utils::play_sound(const QString songName)
{
	emit do_play_sound(songName);
}

void my_utils::stop_sound()
{
	emit do_stop_play_sound();
}

//---------------------------------------------------------------------------//
long GetClassObject(const wchar_t* wsName, IComponentBase** pInterface)
{
	if (!*pInterface)
	{
		*pInterface = new QtDemoAddInNative();
		return (long long)*pInterface;
	}
	return 0;
}
//---------------------------------------------------------------------------//
long DestroyObject(IComponentBase** pIntf)
{
	if (!*pIntf)
		return -1;

	delete *pIntf;
	*pIntf = 0;
	return 0;
}
//---------------------------------------------------------------------------//
const WCHAR_T* GetClassNames()
{
	return s_names.c_str();
}
//---------------------------------------------------------------------------//


unsigned __stdcall worker_thread(void* arg)
{

	if(!demoQtClass)

	{
		int argc = 0;
		char* argv = { strdup("hi") };

		QStringList paths = QCoreApplication::libraryPaths(); //  qwindows.dll 
		paths.append("c:/QtDemoAddInNative");
		QCoreApplication::setLibraryPaths(paths);

		QApplication* appp;
		appp = new QApplication(argc, &argv);
		appp->setQuitOnLastWindowClosed(false);

		demoQtClass = new QtWidgetsDemoClass;	
		cameraWidget = new QtCameraWidget;
		chatWidget = new QtChatWidget;
		utils = new my_utils;
		
		appp->exec();

		_endthreadex(0);

	}

	return 0;
}


QtDemoAddInNative::QtDemoAddInNative()
{
	
	m_iMemory = nullptr;
	m_iConnect = nullptr;
	
	//QStringList paths = QCoreApplication::libraryPaths(); //  qwindows.dll 
	//paths.append("c:/QtDemoAddInNative");
	//QCoreApplication::setLibraryPaths(paths);

	//hThread = (HANDLE)_beginthread(worker_thread, 0, NULL);
	hThread = (HANDLE)_beginthreadex(NULL, 0, worker_thread, NULL, 0, NULL);

	my_pointer_for_QtDemoAddInNative = this;

}

QtDemoAddInNative::~QtDemoAddInNative()
{
	
	//TerminateThread(hThread, (DWORD)-1);

	CloseHandle(hThread);

	if (utils)
	{
		delete utils;
		utils = 0;
	}
	
}


long QtDemoAddInNative::findName(const wchar_t* names[], const wchar_t* name, const uint32_t size) const
{
	long ret = -1;
	for (uint32_t i = 0; i < size; i++)
	{
		if (!wcscmp(names[i], name))
		{
			ret = i;
			break;
		}
	}
	return ret;
}

bool QtDemoAddInNative::Init(void* pConnection)
{
	m_iConnect = (IAddInDefBase*)pConnection;
	pAsyncEvent = m_iConnect;
	return m_iConnect != NULL;
	
}
//---------------------------------------------------------------------------//
long QtDemoAddInNative::GetInfo()
{
	return 2000;
}
//---------------------------------------------------------------------------//
void QtDemoAddInNative::Done()
{
}
//---------------------------------------------------------------------------//
bool QtDemoAddInNative::RegisterExtensionAs(WCHAR_T** wsExtensionName)
{
	const wchar_t *wsExtension = L"QtDemoAddInNative";
	size_t iActualSize = ::wcslen(wsExtension) + 1;
	WCHAR_T* dest = 0;

	if (m_iMemory)
	{
		if (m_iMemory->AllocMemory((void**)wsExtensionName, (unsigned)iActualSize * sizeof(WCHAR_T)))
			::convToShortWchar(wsExtensionName, wsExtension, iActualSize);
		return true;
	}

	return false;
}
//---------------------------------------------------------------------------//
long QtDemoAddInNative::GetNProps()
{
	return eLastProp;
}
//---------------------------------------------------------------------------//
long QtDemoAddInNative::FindProp(const WCHAR_T* wsPropName)
{
	long plPropNum = -1;
	wchar_t* propName = 0;

	::convFromShortWchar(&propName, wsPropName);
	plPropNum = findName(g_PropNames, propName, eLastProp);

	if (plPropNum == -1)
		plPropNum = findName(g_PropNamesRu, propName, eLastProp);

	delete[] propName;

	return plPropNum;
}
//---------------------------------------------------------------------------//
const WCHAR_T* QtDemoAddInNative::GetPropName(long lPropNum, long lPropAlias)
{
	
	if (lPropNum >= eLastProp)
		return NULL;

	wchar_t *wsCurrentName = NULL;
	WCHAR_T *wsPropName = NULL;
	size_t iActualSize = 0;

	switch (lPropAlias)
	{
	case 0: // First language
		wsCurrentName = (wchar_t*)g_PropNames[lPropNum];
		break;
	case 1: // Second language
		wsCurrentName = (wchar_t*)g_PropNamesRu[lPropNum];
		break;
	default:
		return 0;
	}

	iActualSize = wcslen(wsCurrentName) + 1;

	if (m_iMemory && wsCurrentName)
	{
		if (m_iMemory->AllocMemory((void**)&wsPropName, (unsigned)iActualSize * sizeof(WCHAR_T)))
			::convToShortWchar(&wsPropName, wsCurrentName, iActualSize);
	}

	return wsPropName;

}
//---------------------------------------------------------------------------//
bool QtDemoAddInNative::GetPropVal(const long lPropNum, tVariant* pvarPropVal)
{
	
	return false;
}
//---------------------------------------------------------------------------//
bool QtDemoAddInNative::SetPropVal(const long lPropNum, tVariant* varPropVal)
{
	return false;
}
//---------------------------------------------------------------------------//
bool QtDemoAddInNative::IsPropReadable(const long lPropNum)
{
	return false;
}
//---------------------------------------------------------------------------//
bool QtDemoAddInNative::IsPropWritable(const long lPropNum)
{
	return false;
}
//---------------------------------------------------------------------------//
long QtDemoAddInNative::GetNMethods()
{
	return eLastMethod;
}
//---------------------------------------------------------------------------//
long QtDemoAddInNative::FindMethod(const WCHAR_T* wsMethodName)
{
	long plMethodNum = -1;
	wchar_t* name = 0;

	::convFromShortWchar(&name, wsMethodName);

	plMethodNum = findName(g_MethodNames, name, eLastMethod);

	if (plMethodNum == -1)
		plMethodNum = findName(g_MethodNamesRu, name, eLastMethod);

	delete[] name;

	return plMethodNum;
}
//---------------------------------------------------------------------------//
const WCHAR_T* QtDemoAddInNative::GetMethodName(const long lMethodNum,
	const long lMethodAlias)
{
	if (lMethodNum >= eLastMethod)
		return NULL;

	wchar_t *wsCurrentName = NULL;
	WCHAR_T *wsMethodName = NULL;
	size_t iActualSize = 0;

	switch (lMethodAlias)
	{
	case 0: // First language
		wsCurrentName = (wchar_t*)g_MethodNames[lMethodNum];
		break;
	case 1: // Second language
		wsCurrentName = (wchar_t*)g_MethodNamesRu[lMethodNum];
		break;
	default:
		return 0;
	}

	iActualSize = wcslen(wsCurrentName) + 1;

	if (m_iMemory && wsCurrentName)
	{
		if (m_iMemory->AllocMemory((void**)&wsMethodName, (unsigned)iActualSize * sizeof(WCHAR_T)))
			::convToShortWchar(&wsMethodName, wsCurrentName, iActualSize);
	}

	return wsMethodName;
}
//---------------------------------------------------------------------------//
long QtDemoAddInNative::GetNParams(const long lMethodNum)
{
	
	switch (lMethodNum)
	{
	case eSendText:
		return 1;	
	case ePlaySound:
		return 1;
	default:
		return 0;
	}
	
	return 0;
}
//---------------------------------------------------------------------------//
bool QtDemoAddInNative::GetParamDefValue(const long lMethodNum, const long lParamNum,
	tVariant *pvarParamDefValue)
{
	

	TV_VT(pvarParamDefValue) = VTYPE_EMPTY;

	switch (lMethodNum)
	{
	
	case eSendText:
		// There are no parameter values by default 
		break;
	default:
		return false;
	}

	return false;

}
//---------------------------------------------------------------------------//
bool QtDemoAddInNative::HasRetVal(const long lMethodNum)
{
	switch (lMethodNum)
	{

	case eGetPhoto:
		return true;

	default:
		return false;
	}

	return false;

}


void QtDemoAddInNative::SetStatusBar()
{
	
	WCHAR_T* who = 0, * what = 0, * wdata = 0;
	::convToShortWchar(&who, L"QtDemoAddInNative");
	bool do_it = m_iConnect->SetStatusLine(who);

}

//---------------------------------------------------------------------------//
bool QtDemoAddInNative::CallAsProc(const long lMethodNum,
	tVariant* paParams, const long lSizeArray)
{
	switch (lMethodNum)
	{

	case ePlaySound:
	{

		tVariant* var = paParams;
		QString sound_file = QString::fromStdWString((wchar_t*)var->pwstrVal);
		sound_file = QDir::toNativeSeparators(sound_file);
		utils->play_sound(sound_file);		
	}
	break;

	case eStopSound:
	{

		utils->stop_sound();
	}
	break;


	case eSendError:
	{
		addError(0, L" ", L"", 0);

	}
	break;

	case eSendText:
		if (m_iConnect && lSizeArray)
		{
			//m_iConnect->ResetStatusLine();
			tVariant* var = paParams;
			/*bool do_it = m_iConnect->SetStatusLine(var->pwstrVal);

			if (!do_it)
			{
				addError(0, L" ", L"", 0);
			}*/

			QString main_data = QString::fromStdWString((wchar_t*)var->pwstrVal);
			utils->do_send_data(main_data);
		}
		break;

	
	default:
		return false;
	}

	return true;
}
//---------------------------------------------------------------------------//
bool QtDemoAddInNative::CallAsFunc(const long lMethodNum,
	tVariant* pvarRetValue, tVariant* paParams, const long lSizeArray)
{
	switch (lMethodNum)
	{
		case eGetPhoto:
		{

			QByteArray image_arr = cameraWidget->GetMyPhoto();
			m_iMemory->AllocMemory((void**)&pvarRetValue->pstrVal, image_arr.size());
			memcpy((void*)pvarRetValue->pstrVal, image_arr.data(), image_arr.size());
			pvarRetValue->strLen = image_arr.size();
			TV_VT(pvarRetValue) = VTYPE_BLOB; 
		}

	break;

	}

	return true;

}

void ADDIN_API QtDemoAddInNative::SetUserInterfaceLanguageCode(const WCHAR_T* lang) //
{

	m_userLang.assign(lang);
}



//---------------------------------------------------------------------------//
void QtDemoAddInNative::SetLocale(const WCHAR_T* loc)
{
#if !defined( __linux__ ) && !defined(__APPLE__)
	_wsetlocale(LC_ALL, (wchar_t*)loc);
#else
	//We convert in char* char_locale
	//also we establish locale
	//setlocale(LC_ALL, char_locale);
#endif
}
//---------------------------------------------------------------------------//
bool QtDemoAddInNative::setMemManager(void* mem)
{
	m_iMemory = (IMemoryManager*)mem;
	return m_iMemory != 0;
}
//---------------------------------------------------------------------------//


void QtDemoAddInNative::addError(uint32_t wcode, const wchar_t* source, const wchar_t* descriptor, long code)
{
	if (m_iConnect)
	{
		WCHAR_T *err = 0;
		WCHAR_T *descr = 0;

		::convToShortWchar(&err, source);
		::convToShortWchar(&descr, descriptor);

		m_iConnect->AddError(wcode, err, descr, 0);
		delete[] err;
		delete[] descr;
	}
}
//---------------------------------------------------------------------------//
void QtDemoAddInNative::addError(uint32_t wcode, const char16_t * source, const char16_t * descriptor, long code)
{
	if (m_iConnect)
	{
		m_iConnect->AddError(wcode, source, descriptor, 0);
	}
}
//---------------------------------------------------------------------------//


void QtDemoAddInNative::DoExternalEvent(wchar_t* my_event, wchar_t* mydata)
{
	//if (m_iConnect)
	//{
		WCHAR_T* who = 0, * what = 0, * wdata = 0;
		::convToShortWchar(&who, L"QtDemoAddInNative");
		::convToShortWchar(&what, my_event);
		::convToShortWchar(&wdata, mydata);


		/*if (m_iConnect)
			m_iConnect->SetEventBufferDepth(4000);*/

		m_iConnect->ExternalEvent(who, what, wdata);
		
	//}
}

uint32_t convToShortWchar(WCHAR_T** Dest, const wchar_t* Source, uint32_t len)
{
	if (!len)
		len = ::wcslen(Source) + 1;

	if (!*Dest)
		*Dest = new WCHAR_T[len];

	WCHAR_T* tmpShort = *Dest;
	wchar_t* tmpWChar = (wchar_t*)Source;
	uint32_t res = 0;

	::memset(*Dest, 0, len * sizeof(WCHAR_T));
#ifdef __linux__
	size_t succeed = (size_t)-1;
	size_t f = len * sizeof(wchar_t), t = len * sizeof(WCHAR_T);
	const char* fromCode = sizeof(wchar_t) == 2 ? "UTF-16" : "UTF-32";
	iconv_t cd = iconv_open("UTF-16LE", fromCode);
	if (cd != (iconv_t)-1)
	{
		succeed = iconv(cd, (char**)&tmpWChar, &f, (char**)&tmpShort, &t);
		iconv_close(cd);
		if (succeed != (size_t)-1)
			return (uint32_t)succeed;
	}
#endif //__linux__
	for (; len; --len, ++res, ++tmpWChar, ++tmpShort)
	{
		*tmpShort = (WCHAR_T)*tmpWChar;
	}

	return res;
}
//---------------------------------------------------------------------------//

uint32_t convFromShortWchar(wchar_t** Dest, const WCHAR_T* Source, uint32_t len)
{
	if (!len)
		len = getLenShortWcharStr(Source) + 1;

	if (!*Dest)
		*Dest = new wchar_t[len];

	wchar_t* tmpWChar = *Dest;
	WCHAR_T* tmpShort = (WCHAR_T*)Source;
	uint32_t res = 0;

	::memset(*Dest, 0, len * sizeof(wchar_t));
#ifdef __linux__
	size_t succeed = (size_t)-1;
	const char* fromCode = sizeof(wchar_t) == 2 ? "UTF-16" : "UTF-32";
	size_t f = len * sizeof(WCHAR_T), t = len * sizeof(wchar_t);
	iconv_t cd = iconv_open("UTF-32LE", fromCode);
	if (cd != (iconv_t)-1)
	{
		succeed = iconv(cd, (char**)&tmpShort, &f, (char**)&tmpWChar, &t);
		iconv_close(cd);
		if (succeed != (size_t)-1)
			return (uint32_t)succeed;
	}
#endif //__linux__
	for (; len; --len, ++res, ++tmpWChar, ++tmpShort)
	{
		*tmpWChar = (wchar_t)*tmpShort;
	}

	return res;
}

//---------------------------------------------------------------------------//
uint32_t getLenShortWcharStr(const WCHAR_T* Source)
{
	uint32_t res = 0;
	WCHAR_T *tmpShort = (WCHAR_T*)Source;

	while (*tmpShort++)
		++res;

	return res;
}
//---------------------------------------------------------------------------//

//QThread* thread = QThread::create([]
//	{
//		int argc = 0;
//		char* argv = { strdup("hi") };
//
//		QApplication* appp;
//		appp = new QApplication(argc, &argv);
//		appp->setQuitOnLastWindowClosed(false);
//
//
//		demoQtClass = new QtWidgetsDemoClass;
//		demoQtClass->show();
//
//		utils = new my_utils;
//
//		appp->exec();
//
//
//	});