
#ifndef __QTDEMOADDINNATIVE_H__
#define __QTDEMOADDINNATIVE_H__



#include "qtdemoaddinnative_global.h"

#include <ComponentBase.h>
#include "AddInDefBase.h"
#include "IMemoryManager.h"


#include "QtWidgetsDemoClass.h"
#include "QtCameraWidget.h"
#include "QtChatWidget.h"

//#define HAVE_STRUCT_TIMESPEC



class QTDEMOADDINNATIVE_EXPORT QtDemoAddInNative :   public IComponentBase
{

public:

	enum Props
	{
		eLastProp      // Always last
	};

	enum Methods
	{
		ePlaySound,
		eStopSound,
		eSendError,
		eSendText,
		eGetPhoto,
		eLastMethod      // Always last
	};


    QtDemoAddInNative(void);
	virtual ~QtDemoAddInNative();

	virtual bool ADDIN_API Init(void*);
	virtual bool ADDIN_API setMemManager(void* mem);
	virtual long ADDIN_API GetInfo();
	virtual void ADDIN_API Done();
	// ILanguageExtenderBase
	virtual bool ADDIN_API RegisterExtensionAs(WCHAR_T** wsLanguageExt);
	virtual long ADDIN_API GetNProps();
	virtual long ADDIN_API FindProp(const WCHAR_T* wsPropName);
	virtual const WCHAR_T* ADDIN_API GetPropName(long lPropNum, long lPropAlias);
	virtual bool ADDIN_API GetPropVal(const long lPropNum, tVariant* pvarPropVal);
	virtual bool ADDIN_API SetPropVal(const long lPropNum, tVariant* varPropVal);
	virtual bool ADDIN_API IsPropReadable(const long lPropNum);
	virtual bool ADDIN_API IsPropWritable(const long lPropNum);
	virtual long ADDIN_API GetNMethods();
	virtual long ADDIN_API FindMethod(const WCHAR_T* wsMethodName);
	virtual const WCHAR_T* ADDIN_API GetMethodName(const long lMethodNum,
		const long lMethodAlias);
	virtual long ADDIN_API GetNParams(const long lMethodNum);
	virtual bool ADDIN_API GetParamDefValue(const long lMethodNum, const long lParamNum,
		tVariant *pvarParamDefValue);
	virtual bool ADDIN_API HasRetVal(const long lMethodNum);
	virtual bool ADDIN_API CallAsProc(const long lMethodNum,
		tVariant* paParams, const long lSizeArray);
	virtual bool ADDIN_API CallAsFunc(const long lMethodNum,
		tVariant* pvarRetValue, tVariant* paParams, const long lSizeArray);
	operator IComponentBase*() { return (IComponentBase*)this; }
	// LocaleBase
	virtual void ADDIN_API SetLocale(const WCHAR_T* loc);
	virtual void ADDIN_API SetUserInterfaceLanguageCode(const WCHAR_T* lang) override;
	void DoExternalEvent(wchar_t* my_event, wchar_t* mydata);
	void addError(uint32_t wcode, const wchar_t* source, const wchar_t* descriptor, long code);
	void addError(uint32_t wcode, const char16_t* source, const char16_t* descriptor, long code);
	void SetStatusBar();

private:

	long findName(const wchar_t* names[], const wchar_t* name, const uint32_t size) const;
	
	
	IMemoryManager     *m_iMemory;
	std::u16string      m_userLang;

	HANDLE hThread;

};


class  my_utils : public QObject
{
	Q_OBJECT

public:
	my_utils();
	~my_utils();
	void do_send_data(const QString my_data);
	void play_sound(const QString songName);
	void stop_sound();
	

private slots:
	void do_send_alarm(const QString my_event, const QString my_data);
	void do_send_photo();


signals:
	void do_addTextEdittText(const QString my_data);
	void do_play_sound(const QString sndName);
	void do_stop_play_sound();

};


#endif
